#ifndef _RDUP_TR_H
#define _RDUP_TR_H

#include <glib.h>

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <pwd.h>
#include <grp.h>
#include <time.h>
#include <glob.h>
#include <fcntl.h>
#include <signal.h>
#include <dirent.h>
#include <libgen.h>
#include <syslog.h>
#include <errno.h>
#include <utime.h>
#ifdef HAVE_SYS_SYSMACROS_H
    #include <sys/sysmacros.h>
#endif /* HAVE_SYS_SYSMACROS_H */
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mman.h>

#ifdef HAVE_ARCHIVE_H
#include <archive.h>
#include <archive_entry.h>
#endif /* HAVE_ARCHIVE_H */

#ifdef HAVE_SELECT_H
#include <select.h>
#endif /* HAVE_SELECT_H */

#ifdef HAVE_GETTEXT
#include <libintl.h>
#include <locale.h>
#define _(String) gettext (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)
#else	/* HAVE_GETTEXT */
#define _(String) String
#endif /* HAVE_GETTEXT */

#include "entry.h"
#include "common.h"

#define VERSION     "1.1.3"

#define O_NONE	    0
#define O_TAR	    1
#define O_CPIO	    2
#define O_PAX	    3
#define O_RDUP	    4

#define I_LIST      1	/* the input is a list of files names */
#define I_RDUP      2	/* the input is the standard rdup output */

/* signal.c */
void signal_abort(int);

/* msg.c */
void msg(const char *, ...);
void msgd(const char *, int, const char *, ...);

/* getdelim.c */
ssize_t rdup_getdelim(char **, size_t *, int, FILE *);

/* usage-tr.c */
void usage_tr(FILE *);

/* entry.c */
struct rdup * parse_entry(char *, size_t);
gint rdup_write_header(struct rdup *);
gint rdup_write_data(struct rdup *, char *, size_t);
struct stat * stat_from_rdup(struct rdup *);
gint rdup_write_table(struct rdup *, FILE *);

/* link.c */
gchar *slink(struct rdup *);

/* crypt.c */
struct aes_ctx * crypt_init(gchar *, gboolean);
gchar * crypt_path_ele(struct aes_ctx *, gchar *, GHashTable *);
gchar * decrypt_path_ele(struct aes_ctx *, gchar *, GHashTable *);
gchar * crypt_path(struct aes_ctx *, gchar *, GHashTable *);
gchar * decrypt_path(struct aes_ctx *, gchar *, GHashTable *);
char *  crypt_key(gchar *);
#endif  /* _RDUP_TR_H */
